//------------------------------------------------------------------------------
// <autogenerated>
//     This code was generated by a tool.
//     Runtime Version: 1.1.4322.573
//
//     Changes to this file may cause incorrect behavior and will be lost if 
//     the code is regenerated.
// </autogenerated>
//------------------------------------------------------------------------------

namespace Pdfizer
{
	using System;
	using System.IO;
	using System.Collections;
	using System.Net;
	
	using iTextSharp.text;
	using iTextSharp.text.pdf;

	using NTidy;
	
	/// <summary>
	/// TODO - Add class summary
	/// </summary>
	/// <remarks>
	/// 	created by - dehalleux
	/// 	created on - 13/01/2004 11:47:39
	/// </remarks>
	public class HtmlToPdfConverter
	{
		private TidyDocument html;
		private Document doc;
		private PdfWriter writer;
		private Watermark watermark;
		private Hashtable fonts;
		private Font defaultFont;
		private Section[] currentSections;
		private ArrayList chapters;
		private int numberDepth;
		private ITextProcessor textProcessor;
		private HeaderFooter header;
		private HeaderFooter footer;
		private string imagePath;
		private bool imageUrl;
		
		/// <summary>
		/// Default constructor - initializes all fields to default values
		/// </summary>
		public HtmlToPdfConverter()
		{
			html=null;
			doc=null;
			writer=null;
			watermark = null;
			currentSections = null;
			chapters = null;
			numberDepth = 4;
			defaultFont = FontFactory.getFont(FontFactory.HELVETICA,10,iTextSharp.text.Font.NORMAL);
			textProcessor = new NoChangeTextProcessor();
			header = new HeaderFooter(new Phrase("Generated by the Pdfizer library."),new Phrase());
			header.BorderWidth = 0;
			footer = new HeaderFooter(new Phrase("Generated by the Pdfizer library."),new Phrase());
			imagePath = "";
			imageUrl = false;
			
			fonts=new Hashtable();
			// adding some fonts
			AddFont("p",FontFactory.HELVETICA,10,iTextSharp.text.Font.NORMAL);
			AddFont("pre",FontFactory.COURIER,10,iTextSharp.text.Font.NORMAL);
			AddFont("verbatim",FontFactory.COURIER,10,iTextSharp.text.Font.NORMAL);
			
			AddFont("b",FontFactory.HELVETICA,10,iTextSharp.text.Font.BOLD);			
			AddFont("tt",FontFactory.COURIER,10,iTextSharp.text.Font.COURIER);			
			AddFont("em",FontFactory.HELVETICA,10,iTextSharp.text.Font.ITALIC);			
			AddFont("code",FontFactory.COURIER,10,iTextSharp.text.Font.COURIER);			

			AddFont("chapter",FontFactory.HELVETICA,18,iTextSharp.text.Font.BOLD);			
			AddFont("h1",FontFactory.HELVETICA,16,iTextSharp.text.Font.BOLD);
			AddFont("h2",FontFactory.HELVETICA,14,iTextSharp.text.Font.BOLD);
			AddFont("h3",FontFactory.HELVETICA,12,iTextSharp.text.Font.BOLD);
			AddFont("h4",FontFactory.HELVETICA,10,iTextSharp.text.Font.BOLD);
			AddFont("h5",FontFactory.HELVETICA,10,iTextSharp.text.Font.ITALIC);
			AddFont("h6",FontFactory.HELVETICA,8,iTextSharp.text.Font.NORMAL);
		}
				
		public TidyDocument Html
		{
			get
			{
				return html;
			}
		}
		
		public Document Doc
		{
			get
			{
				return doc;
			}
		}
		
		public PdfWriter Writer
		{
			get
			{
				return writer;
			}
		}
		
		public int NumberDepth
		{
			get
			{
				return numberDepth;
			}
			set
			{
				if (value<0)
					throw new ArgumentException("numberDepth cannot be negative");
				numberDepth = value;
			}
		}
		
		public Watermark Watermark
		{
			get
			{
				return this.watermark;
			}
			set
			{
				this.watermark = value;
			}
		}
		
		public Font DefaultFont
		{
			get
			{
				return defaultFont;
			}
			set
			{
				if (value==null)
					throw new ArgumentNullException("default font");
				defaultFont =value;
			}
		}
		
		public Chapter CurrentChapter
		{
			get
			{
				if (chapters.Count==0)
					return null;
				else
					return chapters[chapters.Count-1] as Chapter;
			}
		}
		
		public Section[] CurrentSections
		{
			get
			{
				return currentSections;
			}
		}

		public ITextProcessor TextProcessor
		{
			get
			{
				return textProcessor;
			}
			set
			{
				if (value==null)
					throw new ArgumentNullException("textProcessor");
				textProcessor = value;
			}

		}

		public HeaderFooter Header
		{
			get
			{
				return header;
			}
			set
			{
				header = value;
			}
		}

		public HeaderFooter Footer
		{
			get
			{
				return footer;
			}
			set
			{
				footer = value;
			}
		}

		public String ImagePath
		{
			get
			{
				return imagePath;
			}
			set
			{
				if (value==null)
					throw new ArgumentNullException("imagePath");
				imagePath = value;
			}
		}

		public bool ImageUrl
		{
			get
			{
				return imageUrl;
			}
			set
			{
				imageUrl = value;
			}
		}
		
		public iTextSharp.text.Font Font(string cssClass)
		{
			if (cssClass==null)
				throw new ArgumentNullException("cssClass");
			if (fonts.Contains(cssClass))
				return fonts[cssClass] as iTextSharp.text.Font;
			else 
				return null;
		}
		
		public iTextSharp.text.Font AddFont(string cssClass, 
		                    string fontName,
		                    float size,
		                    int type
		                    )
		{
			if (cssClass==null)
				throw new ArgumentNullException("cssClass");
			if (fonts.Contains(cssClass))
				throw new ArgumentException("cssClass already present");
			if (fontName==null)
				throw new ArgumentNullException("fontName");
			
			iTextSharp.text.Font f = 
				FontFactory.getFont(fontName,size,type) as iTextSharp.text.Font
				as iTextSharp.text.Font;
			fonts[cssClass]=f;
			
			return f;
		}

		
		public Font AddFont(string cssClass, 
		                    string fontName,
		                    float size,
		                    int type,
		                    Color color
		                    )
		{
			if (cssClass==null)
				throw new ArgumentNullException("cssClass");
			if (fonts.Contains(cssClass))
				throw new ArgumentException("cssClass already present");
			if (fontName==null)
				throw new ArgumentNullException("fontName");
			
			Font f = FontFactory.getFont(fontName,size,type,color);
			fonts[cssClass]=f;
			
			return f;
		}
		
		public Chapter AddChapter(string title)
		{
			if(title==null)
				throw new ArgumentNullException("title");
			
			return AddChapter(new Paragraph(title,Font("chapter")));			
		}
		
		public Chapter AddChapter(Paragraph p)
		{
			Chapter chapter = new Chapter(p,chapters.Count+1);
			chapters.Add(chapter);
			Doc.Add(chapter);
			ClearSections(0);
			
			return CurrentChapter;
		}
		
		public Section AddSection(int level, Paragraph p)
		{
			if (p==null)
				throw new ArgumentNullException("p");
			
			if (CurrentChapter==null)
				throw new Exception("CurrentChapter is not defined");
			
			ClearSections(level);
			if (level>0)
			{
				// creating sections if needed...
				Paragraph empty = new Paragraph();
				if (currentSections[0]==null)
					currentSections[0] = CurrentChapter.addSection(p,NumberDepth);
					
				for(int i = 1;i<level;++i)
				{
					if (currentSections[i]==null)
					{
						currentSections[level]=
							currentSections[level-1].addSection(empty,NumberDepth);
					}
				}
				
				
				Section s = currentSections[level-1].addSection(p,NumberDepth);
				currentSections[level]=s;
				return s;
			}
			else
			{
				Section s = CurrentChapter.addSection(p,NumberDepth);
				currentSections[level]=s;				
				return s;
			}
		}
		
		public void ClearSections(int level)
		{
			for(int i = level; i<CurrentSections.Length;++i)
				CurrentSections[i]=null;
		}
		
		public void Open(string outputFileName)
		{
			if (outputFileName==null)
				throw new ArgumentNullException("outputFileName");
			
			// create document
			doc = new Document();
			chapters = new ArrayList();
			currentSections = new Section[6];
			
			// append .pdf if necessary.
			string fileName = outputFileName;
			if (!fileName.EndsWith("pdf"))
				fileName+=".pdf";
			
			// creates pdf writer
			writer = PdfWriter.getInstance(
				Doc, 
				new FileStream(fileName, FileMode.Create)
				);
			
			// set watermark
			if (Watermark!=null)
				Doc.Add(Watermark);

			// add header
			if (Header!=null)
				Doc.Header = this.Header;
			if (Footer!=null)
				Doc.Footer = this.Footer;
						
			// open document
			Doc.Open();
		}
		
		public void Close()
		{
			this.doc.Close();
			this.html=null;
			this.chapters=null;
			this.currentSections=null;
		}
		
		public void Run(string html)
		{
			if (html==null)
				throw new ArgumentNullException("html");
			
			// parse html code
			this.html = new TidyDocument();
			this.html.LoadString(html);
			this.Html.CleanAndRepair();
						
			// iterate recursively over the elements...			
			AnyHtmlElement any = new AnyHtmlElement(this,null);
			any.ConvertChilds(this.Html.Body);
		}

		public void Run(Uri uri)
		{
			// Initialize the WebRequest.
			WebRequest request = null;
			WebResponse response = null;
			try
			{
				request = WebRequest.Create(uri);
				response = request.GetResponse();
				
				Stream stream = response.GetResponseStream();

				StreamReader reader = new StreamReader(stream);
				Run(reader.ReadToEnd());
			}
			catch(Exception)
			{
				throw;
			}
			finally
			{
				if (response!=null)
					response.Close();				
			}

			
		}
	}
}
